diff --git a/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberInit.uml b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberInit.uml
new file mode 100644
index 0000000..bf899fa
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberInit.uml
@@ -0,0 +1,64 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtFrtSubscriberInit()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_frtsubscriber_t* --
+  The FRT subscriber to initialize.
+  Must not be ""NULL"".
+  ====
+  -- **return** : void --
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+:initialize members;
+note
+  -- urt_basesubscriber_t --
+  * **topic** ← ""NULL""
+  * urtEventListenerInit(**evtListener**)
+  * **lastMessage** ← ""NULL""
+  * **lastMessageTime** ← 0
+  .. URT_CFG_PUBSUB_PROFILING == true ..
+  * **sumLatencies** ← 0
+  * **numMessagesReceived** ← 0
+  -- urt_frtsubscriber_t --
+  .. URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true ..
+  * **deadlineOffset** ← 0
+  .. URT_CFG_PUBSUB_QOS_JITTERCHECK == true ..
+  * **maxJitter** ← 0
+  .. URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true ..
+  * **minLatency** ← 0xF..F
+  * **maxLatency** ← 0
+endnote
+stop
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberSubscribe.uml b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberSubscribe.uml
new file mode 100644
index 0000000..ad77191
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberSubscribe.uml
@@ -0,0 +1,110 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtFrtSubscriberSubscribe()\n
+
+!include ../../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_frtsubscriber_t* --
+  The FRT subscriber which shall subscribe to a topic.
+  Must not be ""NULL"".
+  -- **topic** : urt_topic_t* --
+  The topic to subscribe to.
+  Must not be ""NULL"".
+  -- **messages** : urt_message_t* --
+  ""NULL"" terminated list of messages to contribute to the topic.
+  Messages must not be associated to another topic.
+  Once a message has been contributed, it cannot be removed later.
+  May be ""NULL"" (no messages to contribute).
+  -- **deadline** : urt_delay_t --
+  Maximum latency to consume messages.
+  A value of 0 indicates that latency is of no concern.
+  -- **jitter** : urt_delay_t --
+  Maximum allowed jitter (difference between maximum and minimum latency) when consuming messages.
+  A value of 0 indicates that jitter is of no concern.
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_SUBSCRIBE_TOPICSET"" if the subscriber is already associated to a topic.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Is topic already set?) then (yes)
+  stop
+  note
+    Returns ""URT_STATUS_SUBSCRIBE_TOPICSET"".
+  endnote
+else (no)
+  fork
+    :set topic;
+  fork again
+    #EEEEEE:initialize members;
+    note #EEEEEE
+      -- urt_basesubscriber_t --
+      .. URT_CFG_PUBSUB_PROFILING == true ..
+      * **sumLatencies** ← 0
+      * **numMessagesReceived** ← 0
+      -- urt_frtsubscriber_t --
+      .. URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true ..
+      * **deadlineOffset** ← deadline
+      .. URT_CFG_PUBSUB_QOS_JITTERCHECKS == true ..
+      * **maxJitter** ← jitter
+      .. URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true ..
+      * **minLatency** ← 0xF..F
+      * **maxLatency** ← 0
+    endnote
+  endfork
+  :lock topic;
+  fork
+    if (Messages to contribute?) then (yes)
+      $contribute_messages()
+    else (no)
+    endif
+  fork again
+    fork
+      :set message pointer to topic's latest message;
+    fork again
+      :copy timestamp from topic's latest message;
+    endfork
+  fork again
+    :register to topic's event source;
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of subscribers (@topic);
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberUnsubscribe.uml b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberUnsubscribe.uml
new file mode 100644
index 0000000..e87d9f3
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberUnsubscribe.uml
@@ -0,0 +1,71 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtFrtSubscriberUnsubscribe()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_frtsubscriber_t* --
+  The FRT subscriber to be unsubscribed.
+  Must not be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on sucess.
+  Returns ""URT_STATUS_UNSUBSCRIBE_NOTOPIC"" if the subscriber is not associated to a topic.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nlock topic;
+  fork
+    :unregister event;
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement counter of subscribers (@topic);
+  endfork
+  #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nunlock topic;
+  :reset members;
+  note
+    -- urt_basesubscriber_t --
+    * **topic** ← ""NULL""
+    * **lastMessage** ← ""NULL""
+    * **lastMessageTime** ← 0
+  endnote
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_UNSUBSCRIBE_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/functions.iuml b/doc/activitydiagrams/subscriber/functions.iuml
index f26360d..4882b1d 100644
--- a/doc/activitydiagrams/subscriber/functions.iuml
+++ b/doc/activitydiagrams/subscriber/functions.iuml
@@ -25,14 +25,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
     fork
       :update message pointer;
     fork again
-        :copy timestamp of message;
+      :copy message origin time;
     fork again
       :copy message payload;
-    fork again
-      if (Optional output argument ""latency"" given?) then (yes)
-        :set ""latency"" value (now - message origin time);
-      else (no)
-      endif
     endfork
   }
 !endfunction
@@ -40,9 +35,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /' Find the latest message in the circular message buffer. '/
 !function $find_latest_message()
   partition "find latest message" {
-    :access last read message;
+    :access ""lastMessage"";
     while (Timestamp of next message is younger?) is (yes)
-      :proceed to next message;
+      fork
+        :proceed to next message;
+        #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement counter of consumers left (@message);
+      fork again
+        #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of received messages;
+      endfork
     endwhile (no)
   }
 !endfunction
@@ -53,9 +53,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
     if (Timestamp of last read message euqals local copy?) then (yes)
     else (no)
       while (Timestamp of next message is younger?) is (yes)
+        #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement counter of consumers left (@message);
         :proceed to next message;
       endwhile (no)
     endif
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement counter of consumers left (@message);
     :proceed to next message;
   }
 !endfunction
diff --git a/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberFetchLatestMessage.uml b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberFetchLatestMessage.uml
new file mode 100644
index 0000000..b93e0ee
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberFetchLatestMessage.uml
@@ -0,0 +1,133 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtHrtSubscriberFetchLatestMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_hrtsubscriber_t* --
+  The HRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+  Returns ""URT_STATUS_JITTERVIOLATION"" if the message's latency violated the maximum expected jitter.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  partition "find latest message" {
+    :access ""lastMessage"";
+    while (Timestamp of next message is younger?) is (yes)
+      fork
+        :proceed to next message;
+        fork
+          :decrement message's counter of HRT consumers;
+        fork again
+          #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement message's counter of consumers;
+        fork again
+          #EEEEEE:..//URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true//..\nreset QoS deadline timer;
+        endfork
+      fork again
+        #EEEEEE:..//URT_CFG:PUBSUB_PROFILING == true//..\nincrement counter of received messages;
+      endfork
+      if (HRT counter of a message became 0?) then (yes)
+        :signal topic's condition variable;
+      else (no)
+      endif
+    endwhile (no)
+  }
+  if (Timestamp equals local copy?) then (yes)
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+    endnote
+  else (no)
+    :calculate message latency;
+    fork
+      #EEEEEE:..//URT:CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+    fork again
+      if (Optional ""latency"" output argument given?) then (yes)
+        :set ""latency"" value;
+      else (no)
+      endif
+    endfork
+  endif
+  partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+    if (Latency is within allowed jitter range?) then (yes)
+      if (Latency is lower than ""minlatency""?) then (yes)
+        #EEEEEE:update ""minLatency"" value;
+      elseif (Latency is greater than ""maxLatency"" value?) then (yes)
+        #EEEEEE:update ""maxLatency"" value;
+      else (no)
+      endif
+    else (no)
+      partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true//" #EEEEEE {
+        #EEEEEE:unlock topic;
+        #EEEEEE:call ""urtCoreStopNodes(URT_STATUS_JITTERVIOLATION)"";
+        stop
+        note
+          Returns ""URT_STATUS_JITTERVIOLATION"".
+        endnote
+      }
+    endif
+  }
+  fork
+    $fetch_message()
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true//..\nreset QoS deadline timer;
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_ERROR"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberFetchNextMessage.uml b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberFetchNextMessage.uml
new file mode 100644
index 0000000..9e9d327
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberFetchNextMessage.uml
@@ -0,0 +1,191 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtHrtSubscriberFetchNextMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_hrtsubscriber_t* --
+  The HRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+  Returns ""URT_STATUS_JITTERVIOLATION"" if the message's latency violated the maximum expected jitter.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  if (Next message is younger?) then (yes)
+    :proceed to next message;
+  else (no)
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+    endnote
+  endif
+  fork
+    :calculate message latency;
+    fork
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+    fork again
+      if (Optional ""latency"" output argument given?) then (yes)
+        :set ""latency"" value;
+      else (no)
+      endif
+    endfork
+  fork again
+    :decrement message's HRT counter;
+    if (HRT counter became 0?) then (yes)
+    else (no)
+      :signal topic's condition variable;
+    endif
+  fork again
+    partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+      fork
+        #EEEEEE:decrement counter of consumers left (@message);
+      fork again
+        #EEEEEE:increment counter of received messages;
+      endfork
+    }
+  endfork
+  partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+    if (Latency is within allowed jitter range?) then (yes)
+      if (Latency is lower than ""minLatency""?) then (yes)
+        #EEEEEE:update ""minLatency"" value;
+      elseif (Latency is greater than ""maxLatency""?) then (yes)
+        #EEEEEE:update ""maxLatency"" value;
+      else (no)
+      endif
+    else (no)
+      partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true//" #EEEEEE {
+        #EEEEEE:unlock topic;
+        #EEEEEE:call ""urtCoreStopNodes(URT_STATUS_JITTERVIOLATION)"";
+        stop
+        note
+          Returns ""URT_STATUS_JITTERVIOLATION"".
+        endnote
+      }
+    endif
+  }
+  fork
+    $fetch_message()
+  fork again
+    partition "//URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true//" #EEEEEE {
+      if (Timestamp of next message is younger?) then (yes)
+        #EEEEEE:update QoS deadline timer wrt. next message;
+      else (no)
+        #EEEEEE:reset QoS deadline timer;
+      endif
+    }
+  endfork
+
+/'
+  fork
+    $fetch_message()
+  fork again
+    :calculate message latency;
+    fork
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+    fork again
+      if (Optional ""latency"" output argument given?) then (yes)
+        :set ""latency"" value;
+      else (no)
+      endif
+    endfork
+    partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+      if (Latency is within allowed jitter range?) then (yes)
+        if (Latency is lower than ""minLatency""?) then (yes)
+          #EEEEEE:update ""minLatency"" value;
+        elseif (Latency is greater than ""maxLatency""?) then (yes)
+          #EEEEEE:update ""maxLatency"" value;
+        else (no)
+        endif
+      else (no)
+        :unlock topic;
+        :call ""urtCoreStopNodes(URT_STATUS_JITTERVIOLATION)"";
+        stop
+        note
+          Returns ""URT_STATUS_JITTERVIOLATION"".
+        endnote
+      endif
+    }
+  fork again
+    :decrement message's HRT counter;
+    if (HRT counter became 0?) then (yes)
+    else (no)
+      :signal topic's condition variable;
+    endif
+  fork again
+    partition "//URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true//" #EEEEEE {
+      if (Timestamp of next message is younger?) then (yes)
+        #EEEEEE:update QoS deadline timer wrt. next message;
+      else (no)
+        #EEEEEE:reset QoS deadline timer;
+      endif
+    }
+  fork again
+    partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+      fork
+        #EEEEEE:decrement counter of consumers left (@message);
+      fork again
+        #EEEEEE:increment counter of received messages;
+      endfork
+    }
+  endfork
+'/
+
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberInit.uml b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberInit.uml
new file mode 100644
index 0000000..ad16fed
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberInit.uml
@@ -0,0 +1,68 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtHrtSubscriberInit()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- ""**subscriber** : urt_hrtsubscriber_t*"" --
+  The HRT subscriber to initialize.
+  Must not be ""NULL"".
+  ====
+  -- **return** : void --
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+:initialize members;
+note
+  -- urt_basesubscriber_t --
+  * **topic** ← ""NULL""
+  * urtEventListenerInit(**evtListener**)
+  * **lastMessage** ← ""NULL""
+  * **lastMessageTime** ← 0
+  .. URT_CFG_PUBSUB_PROFILING == true ..
+  * **sumLatencies** ← 0
+  * **numMessagesReceived** ← 0
+  -- urt_hrtsubscriber_t --
+  * **next** ← ""NULL""
+  .. URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true ..
+  * **deadlineOffset** ← 0
+  * urtTimerInit(**qosDeadlineTimer**)
+  .. URT_CFG_PUBSUB_QOS_RATECHECK == true ..
+  * **expectedRate** ← 0
+  .. URT_CFG_PUBSUB_QOS_JITTERCHECK == true ..
+  * **maxJitter** ← 0
+  .. URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true ..
+  * **minLatency** ← 0xF..F
+  * **maxLatency** ← 0
+endnote
+stop
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberSubscribe.uml b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberSubscribe.uml
new file mode 100644
index 0000000..987f5e0
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberSubscribe.uml
@@ -0,0 +1,131 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtHrtSubscriberSubscribe()\n
+
+!include ../../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_hrtsubscriber_t* --
+  The HRT subscriber which shall subscribe to a topic.
+  Must not be ""NULL"".
+  -- **topic** : urt_topic_t* --
+  The topic to subscribe to.
+  Must not be ""NULL"".
+  -- **messages** : urt_message_t* --
+  ""NULL"" terminated list of messages to contribute to the topic.
+  Messages must not be associated to another topic.
+  Once a message has been contributed, it cannot be removed later.
+  May be ""NULL"" (no messages to contribute).
+  -- **deadline** : urt_delay_t --
+  Maximum latency to consume messages.
+  A value of 0 indicates that latency is of no concern.
+  -- **jitter** : urt_delay_t --
+  Maximum allowed jitter (difference between maximum and minimum latency) when consuming messages.
+  A value of 0 indicates that jitter is of no concern.
+  -- **rate** : urt_delay_t --
+  Expected minimum rate of new messages (= mamximum time between consecutive messages).
+  A value of 0 indicates, that rate is of no concern.
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_SUBSCRIBE_TOPICSET"" if the subscriber is already associated to a topic.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Is topic already set?) then (yes)
+  stop
+  note
+    Returns ""URT_STATUS_SUBSCRIBE_TOPICSET"".
+  endnote
+else (no)
+  fork
+    :set topic;
+  fork again
+    #EEEEEE:initialize members;
+    note #EEEEEE
+      -- urt_basesubscriber_t --
+      .. URT_CFG_PUBSUB_PROFILING == true ..
+      * **sumLatencies** ← 0
+      * **numMessagesReceived** ← 0
+      -- urt_hrtsubscriber_t --
+      .. URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true ..
+      * **deadlineOffset** ← deadline
+      .. URT_CFG_PUBSUB_QOS_JITTERCHECKS == true ..
+      * **maxJitter** ← jitter
+      .. URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true ..
+      * **minLatency** ← 0xF..F
+      * **maxLatency** ← 0
+      .. URT_CFG_PUBSUB_QOS_RATECHECKS == true ..
+      * **expectedRate** ← rate
+    endnote
+  endfork
+  :lock topic;
+  fork
+    if (Messages to contribute?) then (yes)
+      $contribute_messages()
+    else (no)
+    endif
+  fork again
+    fork
+      :set message pointer to topic's latest message;
+    fork again
+      :copy timestamp from topic's latest message;
+    endfork
+  fork again
+    :register to topic's event source;
+  fork again
+    fork
+      partition "//URT_CFG_PUBSUB_QOS_RATECHECKS = true//" #EEEEEE {
+        #EEEEEE:access first element of topic's list of HRT subscribers;
+        while (Subscriber is not ""NULL""\nand its ""expectedRate"" is lower?) is (yes)
+          #EEEEEE:proceed to next subscriber;
+        endwhile (no)
+        if (Current subscriber is ""NULL""?) then (yes)
+          #EEEEEE:append self to topic's list of HRT subscribers;
+        else (no)
+          #EEEEEE:insert self in fron of current HRT subscriber;
+        endif
+      }
+    fork again
+      :increment topic's counter of HRT subscribers;
+    endfork
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of subscribers (@topic);
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
